For the complete documentation index, see llms.txt. This page is also available as Markdown.

Partially modify servers

Update the properties of the specified server within the data center.

patch
Authorizations
AuthorizationstringRequired

You will need to base64 encode the string containing your credentials.

Note:

  • Basic Authentication is supported only when 2-Factor Authentication is not configured.
  • Users with 2-Factor Authentication activated must generate new 2FA-secured tokens in the DCD using [Token Manager](https://docs.ionos.com/cloud/set-up-ionos-cloud/management/identity-access-management/token-manager). These tokens do not inherit the 2FA-secured property by default.
  • Token deletion is only possible using the Token Manager.
Separate your username and password with a colon, i.e., username:password and send it as 'Authorization' request header. More details: https://en.wikipedia.org/wiki/Basic_access_authentication
Path parameters
datacenterIdstringRequired

The unique ID of the data center.

serverIdstringRequired

The unique ID of the server.

Query parameters
prettybooleanOptional

Controls whether the response is pretty-printed (with indentations and new lines).

Default: true
depthinteger · int32 · max: 10Optional

Controls the detail depth of the response objects. GET /datacenters/[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on

Default: 0
Header parameters
X-Contract-Numberinteger · int32Optional

Users with multiple contracts must provide the contract number, for which all API requests are to be executed.

Body
templateUuidstringOptional

The ID of the template for creating CUBE or GPU servers. If a template has GPU cards assigned, then it can only be used to create GPU servers, otherwise it can only be used for CUBE servers. The available templates can be found on the templates resource.

Example: 15f67991-0f51-4efc-a8ad-ef1fb31a480c
namestringOptional

The name of the resource.

Example: My resource
hostnamestringOptional

The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters.

Example: myHostname
coresinteger · int32Optional

The total number of cores for the server. It can not be supplied for the VMs that have to be created based on templates. For servers with Confidential Computing enabled, the number of cores must match the amount of cores required by the Confidential Computing image, and this field is immutable once the server has been created — update requests attempting to change it will be rejected.

Example: 4
raminteger · int32Optional

The memory size for the server in MB, such as 2048. Size must be specified in multiples of 256 MB with a minimum of 256 MB; however, if you set ramHotPlug to TRUE then you must use a minimum of 1024 MB. If you set the RAM size more than 240GB, then ramHotPlug will be set to FALSE and can not be set to TRUE unless RAM size not set to less than 240GB. It can not be supplied for the VMs that have to be created based on templates. For servers with Confidential Computing enabled, this field is immutable once the server has been created — update requests attempting to change it will be rejected.

Example: 4096
availabilityZonestring · enumOptional

The availability zone in which the server should be provisioned. For CUBE and GPU servers, the only value accepted is 'AUTO'. For servers with Confidential Computing enabled, this field is immutable once the server has been created — update requests attempting to change it will be rejected.

Example: AUTOPossible values:
vmStatestring · enumRead-onlyOptional

Status of the virtual machine.

Example: RUNNINGPossible values:
cpuFamilystringOptional

CPU architecture on which server gets provisioned; not all CPU architectures are available in all datacenter regions; available CPU architectures can be retrieved from the datacenter resource; must not be provided for CUBE and VCPU servers. If the field is omitted from the request or the value is empty or null, an available CPU architecture will be automatically selected. This field must not be supplied when creating a server with Confidential Computing enabled (i.e. when one of the attached volumes uses a confidential computing image); in that case the CPU family is determined by the image and is selected automatically. On servers with Confidential Computing enabled this field is also immutable — update requests attempting to change it will be rejected.

Example: INTEL_ICELAKE
typestringOptional

Server type: CUBE, ENTERPRISE, VCPU or GPU. Confidential Computing can be enabled only on a server of type ENTERPRISE by creating it with a volume with a Confidential Computing image.

Example: CUBE
enabledFeaturesstring[]Read-onlyOptional

The list of features enabled on this server. An ENTERPRISE server with Confidential Computing enabled will have SEV-SNP as part of this list.

Example: ["SEV-SNP"]
placementGroupIdstringOptional

The placement group ID that belongs to this server; Requires system privileges, for internal usage only

nicMultiQueuebooleanOptional

Activate or deactivate the Multi Queue feature on all NICs of this server. This feature is beneficial to enable when the NICs are experiencing performance issues (e.g. low throughput). Toggling this feature will also initiate a restart of the server. If the specified value is true, the feature will be activated; if it is not specified or set to false, the feature will be deactivated. It is not allowed for servers of type Cube.

Example: true
maxNetworkBandwidthnumber · floatRead-onlyOptional

The maximum bandwidth in Gbps as specified by NQoS tiers

Example: 6
Responses
202

Successful operation

application/json
patch/datacenters/{datacenterId}/servers/{serverId}
PATCH /cloudapi/v6/datacenters/{datacenterId}/servers/{serverId} HTTP/1.1
Host: api.ionos.com
Authorization: Basic username:password
Content-Type: application/json
Accept: */*
Content-Length: 323

{
  "templateUuid": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
  "name": "My resource",
  "hostname": "myHostname",
  "cores": 4,
  "ram": 4096,
  "availabilityZone": "AUTO",
  "bootCdrom": {
    "id": "text",
    "type": "resource"
  },
  "bootVolume": {
    "id": "text",
    "type": "resource"
  },
  "cpuFamily": "INTEL_ICELAKE",
  "type": "CUBE",
  "placementGroupId": null,
  "nicMultiQueue": true
}
{
  "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
  "type": "server",
  "href": "<RESOURCE-URI>",
  "metadata": {
    "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
    "createdDate": "2015-12-04T14:34:09.809Z",
    "createdBy": "user@example.com",
    "createdByUserId": "user@example.com",
    "lastModifiedDate": "2015-12-04T14:34:09.809Z",
    "lastModifiedBy": "user@example.com",
    "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
    "state": "AVAILABLE"
  },
  "properties": {
    "templateUuid": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
    "name": "My resource",
    "hostname": "myHostname",
    "cores": 4,
    "ram": 4096,
    "availabilityZone": "AUTO",
    "vmState": "RUNNING",
    "bootCdrom": {
      "id": "text",
      "type": "resource",
      "href": "<RESOURCE-URI>"
    },
    "bootVolume": {
      "id": "text",
      "type": "resource",
      "href": "<RESOURCE-URI>"
    },
    "cpuFamily": "INTEL_ICELAKE",
    "type": "CUBE",
    "enabledFeatures": [
      "SEV-SNP"
    ],
    "placementGroupId": null,
    "nicMultiQueue": true,
    "maxNetworkBandwidth": 6,
    "maintenanceWindow": {
      "startDate": "2026-08-21T17:00:00Z",
      "endDate": "2026-08-21T19:00:00Z"
    }
  },
  "entities": {
    "cdroms": {
      "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
      "type": "collection",
      "href": "<RESOURCE-URI>",
      "items": [
        {
          "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
          "type": "image",
          "href": "<RESOURCE-URI>",
          "metadata": {
            "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
            "createdDate": "2015-12-04T14:34:09.809Z",
            "createdBy": "user@example.com",
            "createdByUserId": "user@example.com",
            "lastModifiedDate": "2015-12-04T14:34:09.809Z",
            "lastModifiedBy": "user@example.com",
            "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
            "state": "AVAILABLE"
          },
          "properties": {
            "name": "My resource",
            "description": "The image/snapshot of Ubuntu ",
            "location": "us/las",
            "size": 100,
            "cpuHotPlug": true,
            "cpuHotUnplug": true,
            "ramHotPlug": true,
            "ramHotUnplug": true,
            "nicHotPlug": true,
            "nicHotUnplug": true,
            "discVirtioHotPlug": true,
            "discVirtioHotUnplug": true,
            "discScsiHotPlug": true,
            "discScsiHotUnplug": true,
            "exposeSerial": true,
            "requireLegacyBios": true,
            "licenceType": "LINUX",
            "applicationType": "MSSQL-2019-Standard",
            "imageType": "HDD",
            "public": true,
            "imageAliases": [
              "text"
            ],
            "requiredFeatures": [
              "text"
            ],
            "cloudInit": "V1"
          }
        }
      ],
      "offset": 0,
      "limit": 1000,
      "_links": {
        "prev": "<PREVIOUS-PAGE-URI>",
        "self": "<THIS-PAGE-URI>",
        "next": "<NEXT-PAGE-URI>"
      }
    },
    "volumes": {
      "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
      "type": "collection",
      "href": "<RESOURCE-URI>",
      "items": [
        {
          "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
          "type": "volume",
          "href": "<RESOURCE-URI>",
          "metadata": {
            "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
            "createdDate": "2015-12-04T14:34:09.809Z",
            "createdBy": "user@example.com",
            "createdByUserId": "user@example.com",
            "lastModifiedDate": "2015-12-04T14:34:09.809Z",
            "lastModifiedBy": "user@example.com",
            "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
            "state": "AVAILABLE"
          },
          "properties": {
            "name": "My resource",
            "type": "PERFORMANCE",
            "size": 100,
            "availabilityZone": "AUTO",
            "image": "d6ad1576-fde9-4696-aa41-1ebd75bdaf49",
            "imagePassword": "mypass123",
            "sshKeys": [
              "ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCyWh6LZ7f2wxnupVgtK2096bc69Vv9uT2A58lwN3ol0A6mxqlT0f4M1NbarVUxa+MVdxBLud5PvlkbYc9mY91OyzLGZMfVWvhAYz/tJSsDtsgRUl0GFVv332zDWk0i+mAVy0N408OORm5XqV6zvIDaiB/jopyjemUp2rnP7pXU4+98ilZw6ef9DF9y4YZ64mchL5//rcrGm1Lff3pC75X/polGONHeG6m4Vs8eIu+0epJ4PJBxO+rwRYp1zMnn90UCk21KvTcYops2cte7ouXQwkGUq3vmXxnSdvuivK/4JNoFQBsaGV974hDmloS5LOvSJjKpXs8Ed437ln712345",
              "ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAABAQCyWh6LZ7f2wxnupVgtK2096bc69Vv9uT2A58lwN3ol0A6mxqlT0f4M1NbarVUxa+MVdxBLud5PvlkbYc9mY91OyzLGZMfVWvhAYz/tJSsDtsgRUl0GFVv332zDWk0i+mAVy0N408OORm5XqV6zvIDaiB/jopyjemUp2rnP7pXU4+98ilZw6ef9DF9y4YZ64mchL5//rcrGm1Lff3pC75X/polGONHeG6m4Vs8eIu+0epJ4PJBxO+rwRYp1zMnn90UCk21KvTcYops2cte7ouXQwkGUq3vmXxnSdvuivK/asdfghjkjhyutry545tgvbn76e4rf43"
            ],
            "bus": "VIRTIO",
            "licenceType": "LINUX",
            "applicationType": "MSSQL-2019-Standard",
            "cpuHotPlug": true,
            "ramHotPlug": true,
            "nicHotPlug": true,
            "nicHotUnplug": true,
            "discVirtioHotPlug": true,
            "discVirtioHotUnplug": true,
            "exposeSerial": true,
            "requireLegacyBios": true,
            "deviceNumber": 3,
            "pciSlot": 7,
            "backupunitId": "25f67991-0f51-4efc-a8ad-ef1fb31a481c",
            "userData": "text",
            "bootServer": "25f67991-0f51-4efc-a8ad-ef1fb31a481c",
            "bootOrder": "AUTO"
          }
        }
      ],
      "offset": 0,
      "limit": 1000,
      "_links": {
        "prev": "<PREVIOUS-PAGE-URI>",
        "self": "<THIS-PAGE-URI>",
        "next": "<NEXT-PAGE-URI>"
      }
    },
    "nics": {
      "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
      "type": "collection",
      "href": "<RESOURCE-URI>",
      "items": [
        {
          "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
          "type": "nic",
          "href": "<RESOURCE-URI>",
          "metadata": {
            "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
            "createdDate": "2015-12-04T14:34:09.809Z",
            "createdBy": "user@example.com",
            "createdByUserId": "user@example.com",
            "lastModifiedDate": "2015-12-04T14:34:09.809Z",
            "lastModifiedBy": "user@example.com",
            "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
            "state": "AVAILABLE"
          },
          "properties": {
            "name": "My resource",
            "mac": "00:0a:95:9d:68:16",
            "ips": [
              "10.160.12.12"
            ],
            "dhcp": true,
            "ipv6Ips": [
              "2001:db8:b06d:8f5a:0609::1"
            ],
            "ipv6CidrBlock": "2001:db8:b06d:8f5a:0609::/80",
            "dhcpv6": true,
            "lan": 2,
            "firewallActive": false,
            "firewallType": "INGRESS",
            "deviceNumber": 3,
            "pciSlot": 7,
            "vnet": null
          },
          "entities": {
            "flowlogs": {
              "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
              "type": "collection",
              "href": "<RESOURCE-URI>",
              "items": [
                {
                  "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
                  "type": "flow-log",
                  "href": "<RESOURCE-URI>",
                  "metadata": {
                    "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
                    "createdDate": "2015-12-04T14:34:09.809Z",
                    "createdBy": "user@example.com",
                    "createdByUserId": "user@example.com",
                    "lastModifiedDate": "2015-12-04T14:34:09.809Z",
                    "lastModifiedBy": "user@example.com",
                    "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
                    "state": "AVAILABLE"
                  },
                  "properties": {
                    "name": "My resource",
                    "action": "ACCEPTED",
                    "direction": "INGRESS",
                    "bucket": "bucketName/key"
                  }
                }
              ],
              "offset": 0,
              "limit": 1000,
              "_links": {
                "prev": "<PREVIOUS-PAGE-URI>",
                "self": "<THIS-PAGE-URI>",
                "next": "<NEXT-PAGE-URI>"
              }
            },
            "firewallrules": {
              "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
              "type": "collection",
              "href": "<RESOURCE-URI>",
              "items": [
                {
                  "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
                  "type": "firewall-rule",
                  "href": "<RESOURCE-URI>",
                  "metadata": {
                    "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
                    "createdDate": "2015-12-04T14:34:09.809Z",
                    "createdBy": "user@example.com",
                    "createdByUserId": "user@example.com",
                    "lastModifiedDate": "2015-12-04T14:34:09.809Z",
                    "lastModifiedBy": "user@example.com",
                    "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
                    "state": "AVAILABLE"
                  },
                  "properties": {
                    "name": "My resource",
                    "protocol": "TCP",
                    "sourceMac": "00:0a:95:9d:68:16",
                    "ipVersion": "IPv4",
                    "sourceIp": "22.231.113.64",
                    "targetIp": "22.231.113.64",
                    "icmpCode": 0,
                    "icmpType": 8,
                    "portRangeStart": 8,
                    "portRangeEnd": 8,
                    "type": "INGRESS"
                  }
                }
              ],
              "offset": 0,
              "limit": 1000,
              "_links": {
                "prev": "<PREVIOUS-PAGE-URI>",
                "self": "<THIS-PAGE-URI>",
                "next": "<NEXT-PAGE-URI>"
              }
            },
            "securitygroups": "[Circular Reference]"
          }
        }
      ],
      "offset": 0,
      "limit": 1000,
      "_links": {
        "prev": "<PREVIOUS-PAGE-URI>",
        "self": "<THIS-PAGE-URI>",
        "next": "<NEXT-PAGE-URI>"
      }
    },
    "securitygroups": {
      "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
      "type": "collection",
      "href": "<RESOURCE-URI>",
      "items": [
        {
          "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
          "type": "security-group",
          "href": "<RESOURCE-URI>",
          "metadata": {
            "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
            "createdDate": "2015-12-04T14:34:09.809Z",
            "createdBy": "user@example.com",
            "createdByUserId": "user@example.com",
            "lastModifiedDate": "2015-12-04T14:34:09.809Z",
            "lastModifiedBy": "user@example.com",
            "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
            "state": "AVAILABLE"
          },
          "properties": {
            "name": "My security group",
            "description": "My security group description"
          },
          "entities": {
            "rules": {
              "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
              "type": "collection",
              "href": "<RESOURCE-URI>",
              "items": [
                {
                  "id": "15f67991-0f51-4efc-a8ad-ef1fb31a480c",
                  "type": "firewall-rule",
                  "href": "<RESOURCE-URI>",
                  "metadata": {
                    "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
                    "createdDate": "2015-12-04T14:34:09.809Z",
                    "createdBy": "user@example.com",
                    "createdByUserId": "user@example.com",
                    "lastModifiedDate": "2015-12-04T14:34:09.809Z",
                    "lastModifiedBy": "user@example.com",
                    "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
                    "state": "AVAILABLE"
                  },
                  "properties": {
                    "name": "My resource",
                    "protocol": "TCP",
                    "sourceMac": "00:0a:95:9d:68:16",
                    "ipVersion": "IPv4",
                    "sourceIp": "22.231.113.64",
                    "targetIp": "22.231.113.64",
                    "icmpCode": 0,
                    "icmpType": 8,
                    "portRangeStart": 8,
                    "portRangeEnd": 8,
                    "type": "INGRESS"
                  }
                }
              ],
              "offset": 0,
              "limit": 1000,
              "_links": {
                "prev": "<PREVIOUS-PAGE-URI>",
                "self": "<THIS-PAGE-URI>",
                "next": "<NEXT-PAGE-URI>"
              }
            },
            "nics": "[Circular Reference]",
            "servers": "[Circular Reference]"
          }
        }
      ],
      "offset": 0,
      "limit": 1000,
      "_links": {
        "prev": "<PREVIOUS-PAGE-URI>",
        "self": "<THIS-PAGE-URI>",
        "next": "<NEXT-PAGE-URI>"
      }
    },
    "gpus": {
      "id": "25f67991-0f51-4efc-a8ad-ef1fb31a400c",
      "type": "collection",
      "href": "<RESOURCE-URI>",
      "items": [
        {
          "id": "25f67991-0f51-4efc-a8ad-ef1fb31a400c",
          "type": "gpu",
          "href": "<RESOURCE-URI>",
          "metadata": {
            "etag": "45480eb3fbfc31f1d916c1eaa4abdcc3",
            "createdDate": "2015-12-04T14:34:09.809Z",
            "createdBy": "user@example.com",
            "createdByUserId": "user@example.com",
            "lastModifiedDate": "2015-12-04T14:34:09.809Z",
            "lastModifiedBy": "user@example.com",
            "lastModifiedByUserId": "63cef532-26fe-4a64-a4e0-de7c8a506c90",
            "state": "AVAILABLE"
          },
          "properties": {
            "name": "My GPU",
            "vendor": "NVIDIA",
            "model": "A100",
            "type": "passthrough"
          }
        }
      ],
      "offset": 0,
      "limit": 1000,
      "_links": {
        "prev": "<PREVIOUS-PAGE-URI>",
        "self": "<THIS-PAGE-URI>",
        "next": "<NEXT-PAGE-URI>"
      }
    }
  }
}

Last updated

Was this helpful?